# LINCS Rancher setup

We have published an article that describes the setup of Rancher on OpenStack with Cinder storage provision on [Medium](https://medium.com/@zacanbot/kubernetes-with-rancher-on-openstack-f4bfb7985869). However, this document will focus on the specific implementation that was chosen for LINCS.

Firstly, we need to provision a VM from OpenStack. LINCS's Rancher runs on a 2-core VM with 7.5GB RAM, which is probably near the minimum requirements that a typical setup would need to manage their clusters effectively.

## Prepare the VM

Follow the guide [here](docs/node_maintenance.md) to configure networking, install updates, and set the timezone.

## K3s installation

K3s is a lightweight and fast Kubernetes distro from Rancher. It is used to host the Rancher installation.

### Using MySQL based storage

In a previous configuration, we connected Rancher's Kubernetes platform to a MySQL database for easier backup/restore management (pre-rancher2.5 with the backup operator).

Follow this part if you want to use apt-installed MySQL server as the database for K3s.

#### MySQL installation

There are many guides on how to install MySQL but on Ubuntu, it mostly just involves running `sudo apt-get install mysql-server`.

#### Move the MySQL database

We want the database to be located somewhere in `/mnt` since the default storage allocation from CC VMs for root is very limited.

```bash
sudo /etc/init.d/mysql stop
sudo cp -R -p /var/lib/mysql /mnt
sudo chown -R mysql:mysql /mnt/mysql/
```

Edit the MySQL config file:

```bash
sudo nano /etc/mysql/my.cnf   # or perhaps /etc/mysql/mysql.conf.d/mysqld.cnf
```

and add/edit these lines:

```text
[mysqld]
datadir=/your/new/dir/
```

Then edit the apparmor configuration;

```bash
sudo nano /etc/apparmor.d/usr.sbin.mysqld
```

Look for lines beginning with /var/lib/mysql. Change /var/lib/mysql in the lines with the new path and save.

```bash
sudo /etc/init.d/apparmor reload
sudo /etc/init.d/mysql restart
```

#### Install K3s

First, get the root user and password for the mysql database. The default user is `debian-sys-maint` and to get the password, just run `sudo cat /etc/mysql/debian.cnf`. Then change the following command to install K3s.

```bash
sudo curl -sfL https://get.k3s.io | sh -s - server --datastore-endpoint="mysql://debian-sys-maint:9VIA8XQivi0XqAZ1@tcp(localhost:3306)/kubernetes" --flannel-backend host-gw
mkdir .kube
sudo cp /etc/rancher/k3s/k3s.yaml .kube/config
```

### Using the default SQLITE storage (current config)

Start by creating a config file that will set the default data directory as well as the FQDN for the ca certs generated by Rancher.

```bash
sudo mkdir -p /mnt/rancher
sudo mkdir -p /etc/rancher/k3s
sudo nano /etc/rancher/k3s/config.yaml
```

```yaml
write-kubeconfig-mode: "0600"
tls-san:
  - rancher.lincsproject.ca
  - 206.12.90.224
data-dir: /mnt/rancher
```

Then install K3s. Be sure to use the same version if you're going to restore a backup. Installed versions: `v1.27.14+k3s1`

```bash
curl -sfL https://get.k3s.io | INSTALL_K3S_VERSION=v1.27.14+k3s1 sudo -E sh -
sudo chown ubuntu /etc/rancher/k3s/k3s.yaml
export KUBECONFIG=/etc/rancher/k3s/k3s.yaml PATH=$PATH:/usr/local/bin
cat $KUBECONFIG
```

Also add the export command to the end of `.bashrc` so that it is available whenever you log in.

### Uninstall K3s

If you want to remove K3s completely and start over, you can use the following commands:

```bash
/usr/local/bin/k3s-uninstall.sh
sudo rm /mnt/rancher/* -R
# if you installed with mysql:
mysql --execute="DROP DATABASE kubernetes;"
```

## RKE2 for Rancher instead of K3s

Start by creating a config file that will set the default data directory as well as the FQDN for the ca certs generated by Rancher.

```bash
sudo mkdir -p /etc/rancher/rke2
sudo nano /etc/rancher/rke2/config.yaml
```

```yaml
tls-san:
  - rancher.lincsproject.ca
  - 206.12.90.224
data-dir: /mnt/rancher
```

Then install RKE2

```bash
curl -sfL https://get.rke2.io | INSTALL_RKE2_VERSION=v1.21.5+rke2r2 sudo -E sh -
sudo systemctl enable rke2-server.service
sudo systemctl start rke2-server.service
sudo chown ubuntu /etc/rancher/rke2/rke2.yaml
export KUBECONFIG=/etc/rancher/rke2/rke2.yaml PATH=$PATH:/mnt/rancher/bin
journalctl -u rke2-server -f
```

To completely uninstall RKE2:

```bash
/usr/local/bin/rke2-uninstall.sh
```

## Rancher installation

After the k8s cluster is ready, we can go ahead and install Rancher.

First, check that the cluster is ready and whether Helm is installed. If it is not available, you can install it with snap craft:

```bash
kubectl get all --all-namespaces
sudo snap install helm --classic
```

or install Helm via Apt

```bash
curl https://baltocdn.com/helm/signing.asc | sudo apt-key add -
sudo apt-get install apt-transport-https --yes
echo "deb https://baltocdn.com/helm/stable/debian/ all main" | \
  sudo tee /etc/apt/sources.list.d/helm-stable-debian.list
sudo apt-get update
sudo apt-get install helm
```

Then install CertManager and Rancher

```bash
# if restoring a backup, create the backup resources before installing Rancher
helm repo add rancher-stable https://releases.rancher.com/server-charts/stable
helm repo add jetstack https://charts.jetstack.io
helm repo update
helm install cert-manager jetstack/cert-manager \
  --namespace cert-manager --version v1.11.0 --create-namespace --set installCRDs=true
kubectl -n cert-manager rollout status deploy/cert-manager
helm install rancher rancher-stable/rancher --version=2.7.1 \
  --namespace cattle-system --create-namespace \
  --set hostname=rancher.lincsproject.ca \
  --set ingress.tls.source=letsEncrypt --set letsEncrypt.email=pbotha@uoguelph.ca
kubectl -n cattle-system rollout status deploy/rancher
# kubectl -n cattle-system scale --replicas 1 deploy/rancher
```

This should make Rancher available at the hostname specified complete with TLS termination.

To uninstall Rancher and keep K3s, run `sudo helm uninstall rancher --namespace cattle-system`.

To upgrade Rancher, be sure to use the same parameters for helm as when Rancher was installed:

```bash
helm upgrade rancher rancher-stable/rancher --namespace cattle-system --set hostname=rancher.lincsproject.ca --set ingress.tls.source=letsEncrypt --set letsEncrypt.email=pbotha@uoguelph.ca
```

A useful command to tail the Rancher logs to debug cluster creation and other Rancher operations:

```bash
kubectl -n cattle-system logs -l app=rancher -f | \
  grep -v "Updating\|eflector\|Trace\[\|warnings\.go\:80\]"
```

Get ALL resources in a namespace (more than `kubectl get all -n <namespace>`):

```bash
kubectl api-resources --verbs=list --namespaced -o name | \
  xargs -n 1 kubectl get --show-kind --ignore-not-found -n <namespace>
```

Useful command to force-delete a namespace that is stuck:

```bash
kubectl get namespace <to-be-removed> -o json \
  | tr -d "\n" | sed "s/\"finalizers\": \[[^]]\+\]/\"finalizers\": []/" \
  | kubectl replace --raw /api/v1/namespaces/<to-be-removed>/finalize -f -
```

## Log in and add Helm Catalogs

Go to the Rancher URL where you'll be greeted with a form to set the server URL and choose a password.

Once inside you will see the K3s cluster where Rancher is installed, but not much more. A good first task will be to add some useful Helm catalogs to the Rancher repository so that you have more apps available to install on your clusters. Open the Cluster _Explorer_ and the choose Apps & Marketplace on the top left drop-down. Click on Chart Repositories to open the list of Helm repos. The following list of catalogs will provide a useful source of Helm charts in addition to the built-in catalogs (type, name, url):

- banzai https://kubernetes-charts.banzaicloud.com
- bitnami https://charts.bitnami.com/bitnami
- ceph-csi https://ceph.github.io/csi-charts
- elastic https://helm.elastic.co
- gitlab https://charts.gitlab.io/
- helm-stable https://charts.helm.sh/stable
- jetstack https://charts.jetstack.io
- longhorn https://charts.longhorn.io
- prometheus https://prometheus-community.github.io/helm-charts

## Monitoring

Install the latest Monitoring chart from the Rancher Tools menu. You can use default values but choose to edit the yaml before you install and change the following value:

```yaml
alertmanager:
  alertmanagerSpec:
    forceEnableClusterMode: true
```

the above change will fix the issue where the Status tab on the Alartmanager UI reports the cluster status as `disabled`.

### Slack notifications

The Receiver and Route UI in Rancher Monitoring (Rancher v2.6) seems to be somewhat unreliable at the moment. One way to create the route and receiver for Slack notifications is to edit the alert-manager secret and change the `alertmanager.yaml` key to have the following value (the Slack api_url is the webhook address created manually via the Slack admin interface):

```yaml
global:
  resolve_timeout: 5m
receivers:
  - name: "null"
  - name: slack-notifications
    slack_configs:
      - send_resolved: true
        text: '{{ template "slack.rancher.text" . }}'
        api_url: https://hooks.slack.com/services/T66GA4MR6/B02D216BY94/xxxxxxxxxxxxxxxx
route:
  group_by:
    - namespace
  group_interval: 5m
  group_wait: 30s
  receiver: "null"
  repeat_interval: 4h
  routes:
    - match:
        alertname: "Watchdog"
      receiver: "null"
    - match:
        severity: "error|critical"
      receiver: slack-notifications
templates:
  - /etc/alertmanager/config/*.tmpl
```

Alternatively, you can use the `Monitoring -> Alerting -> Routes and Receivers` menu item in the Rancher UI to create a classic Receiver and Route separately. Choose a regex matcher for the matcher in the Route config to set the `severity` label to `warning|error|critical`.

The newer `AlertmanagerConfig` does not seem to work with the current version of Rancher Monitoring (tested with Rancher v2.8.5) - it adds the current namespace to the matcher's filters.
